=== modified file 'bzrlib/win32utils.py'
--- bzrlib/win32utils.py	2010-06-01 14:57:57 +0000
+++ bzrlib/win32utils.py	2010-06-03 21:46:02 +0000
@@ -522,7 +522,7 @@
             trace.mutter('Unable to set hidden attribute on %r: %s', path, e)
 
 
-def _command_line_to_argv(command_line, single_quotes_allowed=False):
+def _win32syscall_command_line_to_argv(command_line, single_quotes_allowed=False):
     """Convert a Unicode command line into a list of argv arguments.
 
     It performs wildcard expansion to make wildcards act closer to how they
@@ -538,16 +538,18 @@
     # First, spit the command line
     s = cmdline.Splitter(command_line, single_quotes_allowed=single_quotes_allowed)
     
-    
+    # Bug #587868 Now make sure that the length of s agrees with sys.argv 
+    # we do this by simply counting the number of arguments in each. The counts should 
+    # agree no matter what encoding sys.argv is in (AFAIK) 
+    # len(arguments) < len (sys.argv) should be an impossibility since python gets 
+    # args from the very same PEB as does GetCommandLineW
     arguments = []
     arguments.extend(s)
-    # Now make sure that the length of sys.argv agree with what we're ben given as a command line
-    # we do this by simply counting the number of arguments. The counts should agree no matter
-    # what encoding sys.argv is in (AFAIK) 
-    # TODO: What if len(arguments) < len (sys.argv)
+    if len(arguments) < len (sys.argv):
+        raise AssertionError("len(GetCommandLineW(...)) < len (sys.argv) should not be possible")
     arguments = arguments[len(arguments) - len(sys.argv):]
     
-    # Now process globs; or metachars in the command line
+    # Carry on to process globs (metachars) in the command line
     argv = process_metachars_in_commandline(arguments)
     return argv
 
@@ -574,7 +576,7 @@
         if command_line is None:
             raise ctypes.WinError()
         # Skip the first argument, since we only care about parameters
-        argv = _command_line_to_argv(command_line)[1:]
+        argv = _win32syscall_command_line_to_argv(command_line)[1:]
             
         return argv
 else:

